﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Infragistics.Win.UltraWinGrid;

namespace _97572
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();
            for (int i = 0; i < 5; i++)
            {
                dt.Columns.Add(string.Format("Col{0}", i), typeof(string));
            }
            

            ultraGrid1.InitializeLayout += new Infragistics.Win.UltraWinGrid.InitializeLayoutEventHandler(ultraGrid1_InitializeLayout);
            ultraGrid1.BeforeRowDeactivate += new CancelEventHandler(ultraGrid1_BeforeRowDeactivate);
            ultraGrid1.BeforeRowUpdate += new CancelableRowEventHandler(ultraGrid1_BeforeRowUpdate);
            
            ultraGrid1.DataSource = ultraGrid2.DataSource=dt;
 
        }

        void ultraGrid1_BeforeRowUpdate(object sender, CancelableRowEventArgs e)
        {
            if (ultraGrid1.ActiveRow.IsAddRow)
            {
                
                e.Cancel = ValidateRowFall(ultraGrid1.ActiveRow);
                if (!e.Cancel)
                    return;
                ultraGrid1.BeginUpdate();
                ultraGrid1.BeforeRowUpdate -= new CancelableRowEventHandler(ultraGrid1_BeforeRowUpdate);

                string activecellKey = ultraGrid1.ActiveCell.Column.Key;
                Dictionary<string, object> rolItems = new Dictionary<string, object>();
                foreach (UltraGridCell cell in e.Row.Cells)
                    rolItems.Add(cell.Column.Key, cell.Value);

                e.Row.Delete(false);

                UltraGridRow row =e.Row.Band.AddNew();
                foreach (UltraGridCell cell in e.Row.Cells)
                    row.Cells[cell.Column.Key].SetValue(rolItems[cell.Column.Key], true);
                
                ultraGrid1.ActiveCell = row.Cells[activecellKey];
                ultraGrid1.BeforeRowUpdate += new CancelableRowEventHandler(ultraGrid1_BeforeRowUpdate);
                ultraGrid1.EndUpdate();
                ultraGrid1.PerformAction(UltraGridAction.EnterEditMode);
            }
           
        }

        void ultraGrid1_BeforeRowDeactivate(object sender, CancelEventArgs e)
        {
            if (ultraGrid1.ActiveRow.IsAddRow)
            {
                e.Cancel = ValidateRowFall(ultraGrid1.ActiveRow);
                ultraGrid1.PerformAction(UltraGridAction.EnterEditMode);
            }
        }

        void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.AllowAddNew = Infragistics.Win.UltraWinGrid.AllowAddNew.TemplateOnBottom;
           
        }


        private bool ValidateRowFall(UltraGridRow row)
        {
            foreach (UltraGridCell item in row.Cells)
            {
                if (item.Value.ToString().Trim().Length <= 0 && !item.Column.Hidden)
                {
                    MessageBox.Show("Please select a value for " + item.Column.Header.Caption.ToString());
                    ((UltraGrid)row.Band.Layout.Grid).ActiveCell = item;
                    return true;
                }
            }
            return false;
        }


    }
}
